.686
.model flat,stdcall
option casemap:none
include windows.inc
include kernel32.inc
includelib kernel32.lib
include .\stdlib.inc


.code

;return 0 if err,else 1
FSCreate proc uses edi, pFStream,pFileName
	mov edi,pFStream
	invoke CreateFile,pFileName,GENERIC_READ or GENERIC_WRITE,FILE_SHARE_READ,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0
	mov [edi].FILESTREAM.hFile,eax
	.if eax != INVALID_HANDLE_VALUE
		invoke GetFileSize,eax,0
		mov [edi].FILESTREAM.dwFsize,eax
		invoke VirtualAlloc,0,eax,MEM_COMMIT,PAGE_EXECUTE_READWRITE
		mov [edi].FILESTREAM.pMem,eax
		.if eax
			lea edx,[edi].FILESTREAM.dwFsize
			push 0
			push edx
			mov ecx,[edi].FILESTREAM.dwFsize
			mov edx,[edi].FILESTREAM.hFile
			push ecx
			push eax
			push edx
			call ReadFile;invoke ReadFile,edx,eax,ecx,esi,0
			.if eax
				mov eax,TRUE
				ret
			.endif
			invoke VirtualFree,[edi].FILESTREAM.pMem,0,MEM_RELEASE
		.endif
		invoke CloseHandle,[edi].FILESTREAM.hFile
	.endif
	xor ecx,ecx
	mov [edi].FILESTREAM.dwFsize,ecx
	mov [edi].FILESTREAM.pMem,ecx
	dec ecx
	mov eax,FALSE
	mov [edi].FILESTREAM.hFile,ecx
	ret
FSCreate endp

FSFree proc pFStream
	mov eax,pFStream
	mov edx,[eax].FILESTREAM.hFile
	.if edx != INVALID_HANDLE_VALUE
		invoke CloseHandle,edx
	.endif
	mov eax,pFStream
	mov edx,[eax].FILESTREAM.pMem
	.if edx != 0
		invoke VirtualFree,edx,0,MEM_RELEASE
	.endif
	ret
FSFree endp

FSFlush proc uses ebx edi pFStream
	mov edi,pFStream
	mov ebx,[edi].FILESTREAM.hFile
	invoke SetFilePointer,ebx,0,0,FILE_BEGIN
	xor edx,edx
	mov ecx,[edi].FILESTREAM.pMem
	push edx
	.if ecx != -1
		mov edx,esp
		invoke WriteFile,ebx,ecx,[edi].FILESTREAM.dwFsize,edx,0
	.endif
	pop eax
	ret
FSFlush endp

;return 0 if err,or num bytes written
FSDump proc uses ebx edi pFStream,dwPos,dwNumBytes,pSaveName
	mov edi,pFStream
	invoke CreateFile,pSaveName,GENERIC_WRITE,0,0,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0
	xor edx,edx
	mov ebx,eax
	push edx
	.if eax != -1
		mov ecx,[edi].FILESTREAM.pMem
		mov edx,esp
		add ecx,dwPos
		invoke WriteFile,ebx,ecx,dwNumBytes,edx,0
		invoke CloseHandle,ebx
	.endif
	pop eax
	ret
FSDump endp

FSDuplicate proc uses esi edi pFStream,pFStreamCopy
	mov esi,pFStream
	mov edi,pFStreamCopy
	mov eax,[esi].FILESTREAM.hFile
	mov ecx,[esi].FILESTREAM.dwFsize
	mov [edi].FILESTREAM.hFile,eax
	mov [edi].FILESTREAM.dwFsize,ecx
	invoke VirtualAlloc,0,ecx,MEM_COMMIT,PAGE_EXECUTE_READWRITE
	mov [edi].FILESTREAM.pMem,eax
	.if eax
		invoke CopyMemory,eax,[esi].FILESTREAM.pMem,[esi].FILESTREAM.dwFsize
		mov eax,TRUE
		ret
	.endif
	mov eax,FALSE
	ret
FSDuplicate endp

end