.686
.model flat,stdcall
option casemap:none

include .\stdlib.inc

.code

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

; AMD MANUAL
;64-Bit Left Shift
; Shift EDX:EAX left, shift count in ECX (count
;  applied modulo 64).
U64Shl proc ull1:QWORD,sc:DWORD
	mov eax,[esp+1*4].U64.Lo;ull1
	mov edx,[esp+1*4].U64.Hi;ull1
	mov ecx,[esp+3*4];sc
	shld edx, eax, cl   ; First apply shift count.
	shl  eax, cl        ; mod 32 to EDX:EAX
	test ecx, 32        ; Need to shift by another 32?
	jz   lshift_done    ; No, done.
	mov  edx, eax       ; Left shift EDX:EAX
	xor  eax, eax       ;  by 32 bits
lshift_done:
	ret 3*4
U64Shl endp

OPTION PROLOGUE:PROLOGUEDEF 
OPTION EPILOGUE:EPILOGUEDEF

end
