@echo off
del *.obj
del stdlib.lib
dir /b /S .\String\*.asm > ml.rsp
dir /b /S .\Convert\*.asm >> ml.rsp
dir /b /S .\Std\*.asm >> ml.rsp
dir /b /S .\File\*.asm >> ml.rsp
dir /b /S .\Ini\*.asm >> ml.rsp
dir /b /S .\Registry\*.asm >> ml.rsp
dir /b /S .\Console\*.asm >> ml.rsp
dir /b /S .\RtStartup\*.asm >> ml.rsp
echo ...asm to obj...
\masm32\bin\ml /nologo /c /coff /I"\MASM32\INCLUDE" @ml.rsp
if errorlevel 1 goto mlerr
echo ...obj to lib...
\masm32\bin\link /lib /nologo /LIBPATH:"\MASM32\LIB" /DEFAULTLIB:KERNEL32.LIB /VERBOSE *.obj /out:Stdlib.lib
if errorlevel 1 goto liberr
echo ...lib to path...
copy stdlib.lib \masm32\lib\stdlib.lib
copy stdlib.inc \masm32\include\stdlib.inc
copy stdlib.mac \masm32\include\stdlib.mac
del *.obj
goto end
:mlerr
echo.
echo ***ERROR*** while compiling
pause
goto end
:liberr
echo.
echo ***ERROR*** while linking
pause
goto end
:end
