.686
.model flat,stdcall
option casemap:none

CHR_UPPER equ 00000001b
CHR_LOWER equ 00000010b
CHR_DIGIT equ 00000100b
CHR_DELIM equ 00001000b
CHR_PUNCT equ 00010000b
CHR_CNTRL equ 00100000b
CHR_SPACE equ 01000000b
CHR_HEX   equ 10000000b
CHR_ALPHA equ CHR_LOWER or CHR_UPPER
CHR_ALNUM equ CHR_LOWER or CHR_UPPER or CHR_DIGIT
CHR_PRINT equ CHR_LOWER or CHR_UPPER or CHR_DIGIT or CHR_PUNCT or CHR_SPACE

;PUBLIC ChrFlagTable

.data

ChrFlagTable label byte
db  9 dup    (00100000b); #0..
db  5 dup    (00101000b); #TAB,#LF,#CR,..
db 18 dup    (00100000b); 
db  1 dup    (01001000b); #SPACE
db 15 dup    (00010000b); !"#$%&'()*+,-./
db 10 dup    (10000100b); 0123456789
db  7 dup    (00010000b); :;<=>?@
db  6 dup    (10000001b); ABCDEF
db 20 dup    (00000001b); GHIJKLMNOPQRSTUVWXYZ
db  6 dup    (00010000b); [\]^_`
db  6 dup    (10000010b); abcdef
db 20 dup    (00000010b); ghijklmnopqrstuvwxyz
db  4 dup    (00010000b); {|}~
;db 128 dup(0)

.code

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

ChrTest proc ChrByte:DWORD,ChrFlags:DWORD
	movzx eax,byte ptr[esp+1*4];ChrByte
	movzx edx,byte ptr[esp+2*4];ChrFlags
	cmp al,7Eh
	ja @F
	test [ChrFlagTable+eax],dl
	setnz dh
@@:	mov al,dh
	ret	2*4
ChrTest endp

OPTION PROLOGUE:PROLOGUEDEF 
OPTION EPILOGUE:EPILOGUEDEF

ChrTestEax macro Flags:REQ
LOCAL @1
	cmp eax,7Fh
	jae @1
	test byte ptr [ChrFlagTable+eax],Flags
	setnz ah
@1:	movzx eax,ah
	exitm <eax>
endm

end